﻿using Microsoft.AspNetCore.Mvc;
using MineServer.Model;
using MineServer.Services;
using MongoDB.Bson;
using MongoDB.Bson.Serialization;
using Newtonsoft.Json.Linq;

namespace MineServer.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class PlayerInfoController
    {
        const string AppSecret = "d26b85044c645ac6c40ae56849b35c56";
        const string AppID = "wx3f9ccac98613fabc";

        private readonly PlayerInfoQueryService _playerInfoQueryService;

        public PlayerInfoController(PlayerInfoQueryService playerInfoQueryService) 
        {
            _playerInfoQueryService = playerInfoQueryService;
        }

        [HttpGet("Login")]
        public async Task<string> Login(string code) 
        {
            PlayerInfo playerInfo;
            if (code=="123321")
            {
                playerInfo = await _playerInfoQueryService.GetPlayerIInfo(code);
                if (playerInfo == null)
                {
                    playerInfo = _playerInfoQueryService.NewPlayerInfo(code, "123");
                }
            }
            else
            {
                string url = $"https://api.weixin.qq.com/sns/jscode2session?appid={AppID}&secret={AppSecret}&js_code={code}&grant_type=authorization_code";
                HttpClient client = new HttpClient();
                var res = await client.GetAsync(url);
                var jsonRes = await res.Content.ReadAsStringAsync();
                Console.WriteLine(jsonRes);
                JObject jRes = JObject.Parse(jsonRes);

                var errorcodeJson = jRes["errcode"];
                if (errorcodeJson != null)
                {

                }
                playerInfo = await _playerInfoQueryService.GetPlayerIInfo(jRes["openid"].Value<string>());
                if (playerInfo == null)
                {
                    playerInfo = _playerInfoQueryService.NewPlayerInfo(jRes["openid"].Value<string>(), jRes["session_key"].Value<string>());
                }
            }

            _playerInfoQueryService.RefreshUpgrades(playerInfo);
            _playerInfoQueryService.RefreshWorkbenchInfos(playerInfo);
            return playerInfo.PlayerData.ToBsonDocument().ToString();
        }






    }
}
