﻿using MongoDB.Bson.Serialization.Attributes;

namespace MineServer.Model
{
    public class PlayerInfo 
    {
        [BsonId]
        public string openid { get; set; }
        public string session_key { get; set; }
        public PlayerData PlayerData { get; set; }
        public List<int> CompletedUpgrades { get; set; } = new List<int>();
    }
    
    public class PlayerData
    {
        [BsonDictionaryOptions(MongoDB.Bson.Serialization.Options.DictionaryRepresentation.ArrayOfArrays)]
        public Dictionary<string, uint> Storage { get; set; } = new Dictionary<string, uint>() { { "金币",2000 } };

        public int PlayerToolLevel { get; set; } = 1;

        public int TicketLimit { get; set; } = 5;

        public int CurretnTicket { get; set; } = 5;

        public long LatestTicketTime { get; set; }

        public int ManualLimit { get; set; } = 20;

        public int StartLevel { get; set; } = 0;
        //升级项目
        public List<UpgradeInfo> UpgradeInfos = new List<UpgradeInfo>();
        //工作台项目
        public List<WorkbenchInfo> WorkbenchInfos = new List<WorkbenchInfo>();
    }
}
